<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <!-- Initialize Bootstrap 4 -->
    <link rel="stylesheet" href="https://cdn.staticfile.org/twitter-bootstrap/4.3.1/css/bootstrap.min.css">
    <script src="https://cdn.staticfile.org/jquery/3.2.1/jquery.min.js"></script>
    <script src="https://cdn.staticfile.org/popper.js/1.15.0/umd/popper.min.js"></script>
    <script src="https://cdn.staticfile.org/twitter-bootstrap/4.3.1/js/bootstrap.min.js"></script>
    <link rel="stylesheet" type="text/css" href="css/global.css">
    <script src="getTokenFromCookie.js"></script>
    <script src="parseJwt.js"></script>
    <title>Liste des Cours</title>
</head>

<body>
	<ul class="nav justify-content-end">
		<li class="nav-item">
			<button type="button" id="bouton-logout" class="btn btn-light" style="border: 0.5px solid lightgray;">Log out</button>
			<button type="button" id="bouton-fichiers" class="btn btn-light" style="border: 0.5px solid lightgray;">Accueil</button>
		</li>
	</ul>
	
    <h1>Liste des cours</h1>
    <table class="table table-hover">
        <thead>
            <th>Annee</th>
            <th>Cours</th>
            <th>Nom du cours</th>
            <th>Description</th>
            <th>Enseignants</th>
        </thead>
        <tbody id="list_courses">
        </tbody>
    </table>

    <!--Visible pour les profs-->
    <div id="addfichier" style="display: none;">
        <h4>Ajouter un fichier</h4>
        <form>
            <span id="options_cours">
            </span>
            <input type="file" id="input-file" class="file-upload" />
            <button class="btn btn-success" id="ajoutfichier">Ajouter</button>
        </form>
    </div>


    <!--Visible pour admin-->
    <div id="addcourse" style="display: none;">
        <div >
            <button class="btn btn-outline-success" data-toggle="modal" data-target="#courses">Ajouter ou Modifier Un
                Cours</button>
        </div>
        <div class="modal fade" id="courses" >
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h4 class="modal-title">Ajouter ou modifier un cours</h4>
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                    </div>

                    <div class="modal-body">
                        <form>
                            <table>
                                <tr>
                                    <td>Annee</td>
                                    <td>
                                        <div class="input-group">
                                            <input type="text" class="form-control" id="year">
                                            <div class="input-group-append">
                                                <span class="input-group-text">IF</span>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                                <tr>
                                    <td>Cours</td>
                                    <td><input type="text" class="form-control" id="courseid"></td>
                                </tr>
                                <tr>
                                    <td>Nom du Cours</td>
                                    <td><input type="text" class="form-control" id="coursename"></td>
                                </tr>
                                <tr>
                                    <td>Description</td>
                                    <td><input type="text" class="form-control" id="description"></td>
                                </tr>
                                <tr>
                                    <td>Enseignants</td>
                                    <td><input type="text" class="form-control" id="professors"></td>
                                </tr>
                            </table>
                        </form>
                    </div>

                    <div class="modal-footer">
                        <button type="submit" class="btn btn-primary" id="sauvgarder">Sauvgarder</button>
                    </div>
                </div>
            </div>
        </div>
    </div>


    <script>
        $(document).ready(function () {
			
			$('#bouton-logout').on('click', function () {
				document.cookie = "token=;expires=Thu, 01 Jan 1970 00:00:01 GMT";
				window.location.href= "login.html";
			});
			$('#bouton-fichiers').on('click', function () {
				window.location.href= "fichiers.html";
			});
		
            let token = parseJwt(getTokenFromCookie());
            let role = token.roles;
            console.log(token)
            console.log(role[0])
            if (role.includes("admin")) {
                let addcourse = document.getElementById("addcourse");
                addcourse.style.display = "block";
                $.ajax({
                    type: "GET",
                    async: true,
                    headers: { "Authorization": "Bearer " + getTokenFromCookie() },
                    url: "/api/admin/course",
                    success: (data) => {
                        var jsonData = JSON.parse(data);
                        console.log(jsonData)
                        console.log(jsonData.result)
                        var uploadfileoption = $("#options_cours")
                        var option = "<select id='course_value'>"
                        $.each(jsonData.result, function () {
                            var thedata = $("#list_courses");
                            var trData = "<tr data-toggle='modal' data-target='#courses' data-year=" + this.year.toString() + " data-courseid=" + this.courseid.toString() + " data-coursename=" + this.coursename.toString() + " data-professors=" + this.professors.toString() + " data-description=" + this.description.toString() + "><th>" + this.year.toString() + "</th><th>" + this.courseid.toString() + "</th><th>" + this.coursename.toString() + "</th><th>" + this.description.toString() + "</th><th>" + this.professors.toString() + "</th></tr>";
                            console.log(thedata)
                            console.log(trData)
                            thedata.append(trData);

                            option += "<option value='" + this.courseid + "'>" + this.courseid + "</option>"

                        })
                        option += "</select>"
                        console.log(uploadfileoption)
                        console.log(option)
                        uploadfileoption.append(option)
                    },
                    error: (err) => {
                        this.loginLoading = false;
                        console.log("Error message1：" + JSON.stringify(err))
                        alert("Error message1：" + JSON.stringify(err))
                    }
                })
            }
            else if (role.includes("professor")) {
                $.ajax({
                    type: "GET",
                    async: true,
                    headers: { "Authorization": "Bearer " + getTokenFromCookie() },
                    url: "/api/course?professors=" + token.username,
                    success: (data) => {
                        var jsonData = JSON.parse(data);
                        console.log(jsonData)
                        console.log(jsonData.result)
                        var uploadfileoption = $("#options_cours")
                        var option = "<select id='course_value'>"
                        $.each(jsonData.result, function () {
                            var thedata = $("#list_courses");
                            var trData = "<tr><td>" + this.year.toString() + "</td><td>" + this.courseid.toString() + "</td><td>" + this.coursename.toString() + "</td><td>" + this.description.toString() + "</td><td>" + this.professors.toString() + "</td></tr>";
                            console.log(thedata)
                            console.log(trData)
                            thedata.append(trData);
                            option += "<option value='" + this.courseid + "'>" + this.courseid + "</option>"
                        })
                        option += "</select>"
                        console.log(uploadfileoption)
                        console.log(option)
                        uploadfileoption.append(option)
                    },
                    error: (err) => {
                        this.loginLoading = false;
                        console.log("Error message1：" + JSON.stringify(err))
                        alert("Error message1：" + JSON.stringify(err))
                    }
                })
            }
            else {
                $.ajax({
                    type: "GET",
                    async: true,
                    headers: { "Authorization": "Bearer " + getTokenFromCookie() },
                    url: "/api/course?year=" + token.year,
                    success: (data) => {
                        var jsonData = JSON.parse(data);
                        console.log(jsonData)
                        console.log(jsonData.result)
                        $.each(jsonData.result, function () {
                            var thedata = $("#list_courses");
                            var trData = "<tr><td>" + this.year.toString() + "</td><td>" + this.courseid.toString() + "</td><td>" + this.coursename.toString() + "</td><td>" + this.description.toString() + "</td><td>" + this.professors.toString() + "</td></tr>";
                            console.log(thedata)
                            console.log(trData)
                            thedata.append(trData);
                        })
                    },
                    error: (err) => {
                        this.loginLoading = false;
                        console.log("Error message1：" + JSON.stringify(err))
                        alert("Error message1：" + JSON.stringify(err))
                    }
                })
            }
            if(role.includes("professor")){
                let addfichier = document.getElementById("addfichier");
                addfichier.style.display = "block";
            }
           
        });
        $('#courses').on('show.bs.modal', function (event) {
            let courseid = $(event.relatedTarget).data('courseid')
            console.log(courseid)
            if (courseid) {    // Update
                console.log("update")
                let coursename = $(event.relatedTarget).data('coursename')
                let description = $(event.relatedTarget).data('description')
                let year = $(event.relatedTarget).data('year')
                let professors = $(event.relatedTarget).data('professors')
                $(document).find('.modal-body #courseid').val(courseid)
                $(document).find('.modal-body #coursename').val(coursename)
                $(document).find('.modal-body #year').val(year)
                $(document).find('.modal-body #description').val(description)
                $(document).find('.modal-body #professors').val(professors)
                $("#sauvgarder").click(function (e) {
                    let reqUrl = "/api/admin/course?courseid=" + courseid;
                    let newCourseName = $("#coursename").val();
                    if (newCourseName)
                        reqUrl = reqUrl + "&coursename=" + newCourseName;
                    let newYear = $("#year").val();
                    if (newYear)
                        reqUrl = reqUrl + "&year=" + newYear;
                    let newDescription = $("#description").val();
                    if (newDescription)
                        reqUrl = reqUrl + "&description=" + newDescription;
                    console.log(newCourseName)
                    console.log(newYear)
                    console.log(newDescription)
                    let newProf = $("#professors").val();
                    if (newProf)
                        reqUrl = reqUrl + "&professors=" + newProf;
                    console.log(newProf)
                    $.ajax({
                        type: "POST",
                        headers: { "Authorization": "Bearer " + getTokenFromCookie() },
                        url: reqUrl,
                        success: (data) => {
                            console.log("course modified")
                            location.reload()
                        },
                        error: (err) => {
                            this.loginLoading = false;
                            console.log("Error message1：" + JSON.stringify(err))
                            alert("Error message1：" + JSON.stringify(err))
                        }
                    })
                });

            }

            else {       //Ajout
                console.log("Ajout")
                $("#sauvgarder").click(function (e) {
                    let newCourseName = $("#coursename").val();
                    let newCourseID = $("#courseid").val();
                    let newYear = $("#year").val();
                    let newDescription = $("#description").val();
                    console.log(newCourseName)
                    console.log(newCourseID)
                    console.log(newYear)
                    console.log(newDescription)
                    let newProf = $("#professors").val();
                    console.log(newProf)
                    $.ajax({
                        type: "PUT",
                        headers: { "Authorization": "Bearer " + getTokenFromCookie() },
                        url: "/api/admin/course?courseid=" + newCourseID + "&coursename=" + newCourseName + "&professors=" + newProf + "&year=" + newYear + "&description=" + newDescription,
                        success: (data) => {
                            console.log("course added")
                            location.reload()
                        },
                        error: (err) => {
                            this.loginLoading = false;
                            console.log("Error message1：" + JSON.stringify(err))
                            alert("Error message1：" + JSON.stringify(err))
                        }
                    })
                });
            }
        });
        $("#ajoutfichier").click(function (e) {
            let courseid = $("#course_value").val();
            let upload_file = document.getElementById("input-file").files[0];
            let formData = new FormData();

            formData.append("file", upload_file);
            console.log(courseid)
            $.ajax({
                type: "POST",
                headers: { "Authorization": "Bearer " + getTokenFromCookie() },
                data: formData,
                //body:formData,
                async: false,
                cache: false,
                contentType: false,
                enctype: 'multipart/form-data',
                processData: false,
                url: "/api/course/file?courseid=" + courseid,

                success: (data) => {
                    console.log("file uploaded")
                },
                error: (err) => {
                    this.loginLoading = false;
                    console.log("Error message1：" + JSON.stringify(err))
                    alert("Error message1：" + JSON.stringify(err))
                }
            })
        });
    </script>
</body>

</html>
